\\ Copyright 2017, 2018, 2019, 2020 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ Count trees or forests where different types of seq vertex sequences come
\\ out the same.


default(recover,0)
read("../vpar.gp");
read("../vpar-wip.gp");
setrand(getwalltime()%2^32);


\\-----------------------------------------------------------------------------
\\ counts of same seqs

\\ forests
\\ totals      [1, 3, 16, 125, 1296, 16807]
\\ trees
\\ totals      [1, 2, 9, 64, 625, 7776, 117649]
\\
\\ upascend == upascend,ahead=1
\\ not in OEIS: 1, 3, 15, 107, 997, 11503, 158531
\\ vecs
\\ not in OEIS: 1, 3, 16, 117, 1096, 12625, 173314
\\ tree
\\ not in OEIS: 1, 2, 9, 60, 535, 5982, 80521
\\ vecs
\\ not in OEIS: 1, 2, 9, 64, 585, 6576, 88375
\\
\\ upascend == subtree_height
\\ not in OEIS: 1, 2, 9, 56, 460, 4614
\\ vecs
\\ not in OEIS: 1, 2, 9, 64, 545, 5556
\\ seqs diff 
\\ not in OEIS:          8, 165, 3162
\\ vecs diff  
\\ not in OEIS:             80, 2220
\\
\\ fromleaf == leafphases
\\ not in OEIS: 1, 3, 14, 92, 729, 6472, 62583
\\ vecs
\\ not in OEIS: 1, 3, 16, 109, 886, 8044, 79274
\\
\\ fromleaf == upqueue
\\ not in OEIS: 1, 3, 14, 89, 715, 6946, 79219
\\ vecs
\\ not in OEIS: 1, 3, 16, 109, 896, 8743, 99366
\\ tree
\\ not in OEIS: 1, 2, 9, 56, 445, 4290, 48622
\\ vecs
\\ not in OEIS: 1, 2, 9, 64, 545, 5376, 61201
\\
\\ fromleaf == forward childless_paths
\\   [1, 2, 6, 24, 120, 720]      factorials
\\ vecs
\\ not in OEIS: 1, 3, 10, 49, 306, 2305, 20294
\\ tree
\\ seqs [1, 2, 6, 24, 120, 720, 5040] factorials
\\ vecs
\\ not in OEIS: 1, 2, 9, 40, 245, 1836, 16135
\\
\\ fromleaf == childless_paths
\\   [1, 1, 1, 1, 1, 1]
\\   vecs  [1, 1, 1, 1, 1, 1]
\\ tree
\\ seqs  [1, 0, 0, 0, 0, 0, 0]
\\ vecs  [1, 0, 0, 0, 0, 0, 0]
\\
\\ -------
\\
\\ postorder == leafphases
\\ not in OEIS: 1, 3, 13, 77, 551, 4387, 37822
\\ vecs
\\ not in OEIS: 1, 3, 16, 101, 726, 5767, 49589
\\
\\ postorder == upqueue
\\ not in OEIS: 1, 3, 13, 77, 581, 5347, 58227
\\ not quite A273953 = 1,1,3,13,77,581,5347,58213
\\ vecs
\\ not in OEIS: 1, 3, 16, 101, 756, 6787, 72094
\\ tree
\\ not in OEIS: 1, 2, 9, 52, 385, 3486, 37429
\\ vecs
\\ not in OEIS: 1, 2, 9, 64, 505, 4536, 47509
\\
\\ postorder == forward childless_paths
\\   [1, 2, 6, 24, 120, 720]      factorials
\\ vecs
\\ not in OEIS: 1, 3, 10, 49, 316, 2503, 23360
\\ tree
\\ seqs  [1, 2, 6, 24, 120, 720, 5040]
\\ vecs
\\ not in OEIS: 1, 2, 9, 40, 245, 1896, 17521
\\
\\ postorder == childless_paths
\\   [1, 1, 1, 1, 1, 1]
\\  vecs  [1, 1, 1, 1, 1, 1]
\\
\\ -----------
\\ leafphases == upqueue
\\ not in OEIS: 1, 3, 16, 119, 1086, 11382, 133589
\\ vecs
\\ not in OEIS: 1, 3, 16, 125, 1176, 12667, 153364
\\
\\ leafphases == forward childless_paths
\\ [1, 2, 6, 24, 120, 720, 5040]  factorials
\\ vecs
\\ not in OEIS: 1, 3, 10, 49, 276, 1783, 12881
\\
\\ leafphases == childless_paths
\\   seqs  [1, 1, 1, 1, 1, 1, 1]
\\   vecs  [1, 1, 1, 1, 1, 1, 1]
\\
\\ -----------
\\ upqueue == forward childless_paths
\\   [1, 2, 6, 24, 120, 720]      factorials
\\ vecs
\\ not in OEIS: 1, 3, 10, 49, 276, 1843, 14246
\\ tree
\\   [1, 2, 6, 24, 120, 720]      factorials
\\ vecs
\\ not in OEIS: 1, 2, 9, 40, 245, 1656, 12901
\\
\\ upqueue == childless_paths
\\   [1, 1, 1, 1, 1, 1]
\\ vecs  [1, 1, 1, 1, 1, 1]
\\
\\ forward childless_paths == childless_paths
\\   [1, 0, 0, 0, 0, 0]
\\ vecs
\\ 1, 1, 4, 5, 36, 49, 512
\\ A152291 a(n) = (n+1)^floor((n-1)/2).
\\ A152291 ,1,1,1,4,5,36,49,512,729,10000,...
\\ tree
\\ seqs  [1, 0, 0, 0, 0, 0, 0]
\\ vecs  [1, 0, 0, 0, 0, 0, 0]
\\
\\-----------------------------------------------------------------------------
\\ seq = idseq unchanged trees, ie. vertices already in relevant sequence
\\
\\ num children   (labelled with increasing num children)
\\ 1, 1, 3, 10, 47, 246
\\ A005651 sum multinomial coefficients (n_1+n_2+...)!/(n_1!*n_2!*...)
\\         over partitions n = n_1 + n_2 + ...
\\ changed
\\              0, 1, 6, 54, 578, 7530
\\ not in OEIS:       6, 54, 578, 7530
/* GP-Test  gcd([6, 54, 578, 7530]) == 2 */
\\
\\ upascend unchanged, can add new first vertex anywhere on existing trees
\\ factorial 1, 1, 2, 6, 24, 120, 720, 5040
\\
\\ upascend,ahead=1 unchanged [1, 1, 2, 5, 15, 52, 203, 877]
\\ upqueue unchanged          [1, 1, 2, 5, 15, 52, 203, 877]
\\ childless_paths unchanged       [1, 1, 2, 5, 15, 52, 203, 877]
\\ rows (breadth-first) unchanged    [1, 1, 2, 5, 15, 52]
\\ A000110 Bell numbers, partition a set of n labelled elements
\\ A000110 ,1,1,2,5,15,52,203,877,4140,21147,115975
\\ changed
\\ not in OEIS: 0, 1, 7, 59, 610, 7724
\\
\\ subtree_height unchanged
\\ n =          1  2  3  4   5   6    7     8
\\              1, 1, 2, 5, 16, 61, 268, 1329
\\ See attempts in subtree-height-monotonic.gp
\\ maybe A322616
\\ subtree_height changed
\\ not in OEIS: 0, 1, 7, 59, 609, 7715
\\ subtree_height,down=1 unchanged
\\              1, 1, 2, 5, 16, 61
\\ new t many vertices attach under existing leaves, at least one each
\\
\\ subtree_size unchanged
\\ n =          1  2  3  4   5   6    7     8
\\ not in OEIS: 1, 1, 2, 5, 16, 58, 246, 1141
\\ cf A185143 graphs girth=3  = 1,1,2,5,16,58,264,1535
\\ cf A212263 array something = 1,1,2,5,16,58,222,869
\\ subtree_size changed
\\ not in OEIS: 0, 1, 7, 59, 609, 7718
\\
\\ max or min descendant unchanged
\\ 1, 2, 7, 33, 191, 1297
\\ A104981 = column 1 of A104980
\\ A104980 = matrix something
\\ changed
\\ not in OEIS: 0, 0, 2, 31, 434, 6479
\\
\\ max or min ancestor unchanged
\\ not in OEIS: 1, 2, 8, 47, 365, 3570
\\
\\ min or max childless descendant unchanged
\\ not in OEIS: 1, 2, 8, 42, 266, 1942
\\ changed
\\ not in OEIS: 0, 0, 1, 22, 359, 5834
\\ min or max at_height unchanged
\\ not in OEIS: 1, 2, 8, 44, 296, 2324
\\ changed
\\ not in OEIS: 0, 0, 1, 20, 329, 5452
\\
\\ ----
\\ downsuccessive unchanged
\\ downsuccessive unchanged [1, 1, 2, 6, 24, 120]
\\ factorials
\\ downsuccessive   changed [0, 1, 7, 58, 601, 7656]
\\ A126130 a(n) = (n+1)^n - n!
\\
\\ successive_paths unchanged [1, 2, 6, 24, 120, 720]
\\ factorials
\\ successive_paths   changed [0, 0, 3, 40, 505, 7056]
\\ not in OEIS: 3, 40, 505, 7056
\\ vector(10,n, (n+1)^n - (n+1)!)
\\
\\ ----
\\ forward childless_paths unchanged [1, 1, 1, 1, 1, 1, 1]
\\ forward childless_paths unchanged [1, 0, 0, 0, 0, 0, 0, 0]
\\ childless_paths unchanged [1, 1, 2, 5, 15, 52, 203, 877]
\\
\\ childless_paths unchanged [1, 1, 2, 5, 15, 52, 203]
\\ A000110 Bell numbers, partition a set of n labelled elements
\\ childless_paths   changed [0, 1, 7, 59, 610, 7724, 117446]
\\ childless_paths,down=1 unchanged [1, 1, 2, 5, 15, 52, 203]
\\ childless_paths,down=1   changed [0, 1, 7, 59, 610, 7724, 117446]
\\
\\ ----
\\ pre/postorder unchanged
\\ parent unchanged  1, 1, 2, 5, 14, 42
\\ A000108 Catalan
\\ 1, 1, 2, 5, 14, 42
\\ changed 
\\ not in OEIS: 0, 1, 7, 59, 611, 7734
\\
\\ ----
\\ unchanged trees root=1
\\ upascend unchanged [1, 0, 0, 0, 0, 0, 0, 0]
\\ upascend,ahead=1 unchanged [1, 0, 0, 0, 0, 0, 0, 0]
\\ subtree_height unchanged [1, 0, 0, 0, 0, 0, 0, 0]
\\ upqueue unchanged [1, 0, 0, 0, 0, 0, 0, 0]
\\
\\ ----
\\ unchanged forests
\\ unchanged
\\ upascend unchanged [1, 2, 6, 24, 120, 720]
\\ upascend,ahead=1 unchanged [1, 2, 5, 15, 52, 203]
\\ subtree_height unchanged [1, 2, 5, 16, 61, 268]
\\ upqueue unchanged [1, 2, 5, 15, 52, 203]
\\ forward childless_paths unchanged [1, 1, 1, 1, 1, 1]
\\ childless_paths unchanged [1, 2, 5, 15, 52, 203]
\\
\\ ----
\\ lexmin vpar unchanged [1, 1, 2, 4, 9, 20]
\\ A000081 unlabelled trees canonical form
\\ lexmin vpar   changed [0, 1, 7, 60, 616, 7756]
\\ not in OEIS: 1, 7, 60, 616, 7756
\\
\\ lexmin vpar == childless_paths,down=1
\\   seqs  [1, 2, 9, 40, 205, 1236]
\\ A296964  (x*exp(x)-1)/(1-x)
\\ A038156  n! * Sum_{k=1..n-1} 1/k!      has extra low 0
\\          a(n) = n*(a(n-1) + 1)
\\   vecs  [1, 2, 9, 52, 365, 3006] (new) 
\\ A006152 x*exp(x/(1-x))
\\         labelled rooted trees with every non-root degree 1 or 2
\\
\\ lexmin vpar == subtree_height,down=1
\\   seqs  [1, 2, 9, 52, 335, 2406] (new) 
\\   vecs  [1, 2, 9, 52, 335, 2466] (new) 
\\ A193465 Row sums of triangle A061312.

{
  my(max_n=6,
     forest=0,
     elems=
     [
      ["vpar_seq_diagpost", vpar_seq_diagpost ],
      ["vpar_seq_diagqueue", vpar_seq_diagqueue],
      ["vpar_seq_diagqueue,down=1", (vpar)->vpar_seq_diagqueue(vpar,1)],
      
      [ "vpar_seq_lexmin", vpar_seq_lexmin ],
      [ "num_siblings", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_num_siblings_vector(vpar))],
      [ "vpar_seq_num_children", vpar_seq_num_children],
      [ "siblingpos", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_siblingpos_vector(vpar)) ],
      [ "siblingpos,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_siblingpos_vector(vpar,1)) ],
      
      [ "min descendant then height",
       vpar->
       my(heights    = vpar_subtree_heights_vector(vpar),
          descendant = vpar_minmax_descendants_vector(vpar,min),
          keys       = vector(#vpar,v, [descendant[v], heights[v]]));
       vecsort(keys,,1) \\ flag=1 for seq
      ],
      
      [ "successive_paths", vpar_seq_successive_paths ],
      [ "successive_paths,down=1", vpar->vpar_seq_successive_paths(vpar,1) ],
      [ "childless_paths",        vpar_seq_childless_paths ],
      [ "childless_paths,down=1", vpar->vpar_seq_childless_paths(vpar,1) ],

      [ "upascend", vpar_seq_upascend ],
      [ "upascend,ahead=1", vpar->vpar_seq_upascend(vpar,1)],
      [ "subtree_height", vpar_seq_subtree_height ],
      [ "subtree_height,down=1", vpar->vpar_seq_subtree_height(vpar,1)],
      [ "subtree_size", vpar_seq_subtree_size ],
      [ "subtree_size,down=-1", vpar->vpar_seq_subtree_size(vpar,1) ],
      [ "upqueue", vpar_seq_upqueue ],
      [ "preorder", vpar_seq_preorder ],
      [ "postorder", vpar_seq_postorder ],
      
      ["parent", vpar_INTERNAL_seq_bucket_sort],
      ["parent,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar,1)],

      ["rows",vpar_seq_rows],
      ["rows,up=1",vpar->vpar_seq_rows(vpar,1)],

      ["max child", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_child_vector(vpar,max))],
      ["min child", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_child_vector(vpar,min))],
      ["max child,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_child_vector(vpar,max), 1)],
      ["min child,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_child_vector(vpar,min), 1)],

      ["min descendant", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_descendants_vector(vpar,min))],
      ["max descendant", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_descendants_vector(vpar,max))],
      ["min ancestor", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_ancestors_vector(vpar,min))],
      ["max ancestor", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_ancestors_vector(vpar,max))],
      ["min childless descendant", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_childless_descendants_vector(vpar,min))],
      ["max childless descendant", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_childless_descendants_vector(vpar,max))],
      ["min at_height", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_height_descendants_vector(vpar,min))],
      ["max at_height", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_height_descendants_vector(vpar,max))],
      
      ["min descendant,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_descendants_vector(vpar,min),1)],
      ["max descendant,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_descendants_vector(vpar,max),1)],
      ["min ancestor,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_ancestors_vector(vpar,min),1)],
      ["max ancestor,down=1", vpar->vpar_INTERNAL_seq_bucket_sort(vpar_minmax_ancestors_vector(vpar,max),1)]


      \\ [ "min descendant then depth", \\ = successive_paths
      \\  vpar->
      \\  my(min_descendant = vpar_minmax_descendants_vector(vpar,min),
      \\     depths         = vpar_depths_vector(vpar),
      \\     keys = vector(#vpar,v, [min_descendant[v],depths[v]]));
      \\  vecsort(keys,,1) \\ flag=1 for seq
      \\ ],
      
     ],
     count_seqs=matrix(#elems,#elems,i,j,vector(max_n)),
     count_vecs=matrix(#elems,#elems,i,j,vector(max_n)),
     count_seqs_diff=matrix(#elems,#elems,i,j,vector(max_n)),
     count_vecs_diff=matrix(#elems,#elems,i,j,vector(max_n)),
     count_idseq=vector(#elems,i, vector(max_n)),
     count_diffseq=vector(#elems,i, vector(max_n)),
     totals=vector(max_n),
     seen_all_diff=0);
  for(n=1,max_n,
     my(idseq=vpar_INTERNAL_identity_perm(n));
     forvec(can=vpar_forvec_from(n,forest),
           totals[n]++;
           my(vpar=vpar_from_upascend(can));
           \\ vpar_validate(vpar);

           my(seqs=apply(elem->elem[2](vpar), elems));
           my(vecs=apply(seq->vecextract(vpar,seq),seqs));
           \\ print(seqs);
           if(!seen_all_diff,
              if(#Set(seqs)==#seqs,
                 seen_all_diff=1;
                 print("vpar giving all different "vpar)));

           for(i=1,#elems,
              my(unchanged=(seqs[i]==idseq));
              count_idseq[i][n] += unchanged;
              count_diffseq[i][n] += 1-unchanged;
              for(j=1,#elems,
                 my(seqs_same=(seqs[i]==seqs[j]));
                 count_seqs[i,j][n]      += seqs_same;
                 count_seqs_diff[i,j][n] += !seqs_same;
                 my(vecs_same=(vecs[i]==vecs[j]));
                 count_vecs[i,j][n]      += vecs_same;
                 count_vecs_diff[i,j][n] += !vecs_same;
              ))));

  print("totals "totals);

  print("unchanged");
  my(unchanged_seen=Map());
  for(i=1,#elems,
     my(name=elems[i][1],
        v=count_idseq[i],
        str=if(mapisdefined(unchanged_seen,v),"",
               mapput(unchanged_seen,v,1); "  (new)"));
     print(name," unchanged ",v,str);

     v=count_diffseq[i];
     str=if(mapisdefined(unchanged_seen,v),"",
            mapput(unchanged_seen,v,1); "  (new)");
     print(name,"   changed ",v,str));

  print("cross-same");
  my(cross_seen=Map());
  for(i=1,#elems,
     for(j=i+1,#elems,
        print(elems[i][1]" == "elems[j][1]);
        my(v=count_seqs[i,j],
           str=if(mapisdefined(cross_seen,v),"",
                  mapput(cross_seen,v,1); " (new) "));
        print("  seqs  "v,str,
             if(vecmax(count_seqs[i,j])<=1,"  NONE SAME",""));

        v=count_vecs[i,j];
        str=if(mapisdefined(cross_seen,v),"",
               mapput(cross_seen,v,1); " (new) ");
        print("  vecs  "v,str,
             if(vecmax(count_vecs[i,j])<=1,"  NONE SAME",""));

        v=count_seqs_diff[i,j];
        str=if(mapisdefined(cross_seen,v),"",
               mapput(cross_seen,v,1); " (new) ");
        print("  seqs diff  "v,str,
             if(vecmax(count_seqs_diff[i,j])<=1,"  NONE DIFF",""));

        v=count_vecs_diff[i,j];
        str=if(mapisdefined(cross_seen,v),"",
               mapput(cross_seen,v,1); " (new) ");
        print("  vecs diff  "v,str,
             if(vecmax(count_vecs_diff[i,j])<=1,"  NONE DIFF",""));
     ));

}
quit

