\\ Copyright 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)
\\ default(parisizemax,300*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
read("memoize.gp");
setrand(getwalltime()%2^32);


check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong: "name);
     print("got  "got);
     print("want "want);
     quit(1),
     option_verbose,
     print("ok "check_count" "name));
}

{
  for(n=0,5,
     for(k=1,n,
        printf(" %3d",stirling(n,k,2)));
     print());
}
{
  print("list");
  for(n=0,5,
     for(k=1,n,
        print1(k!*stirling(n,k,2),",")));
  print();
}

\\ A008277 stirling(n,k,2) k=1 to n
\\ A048993 stirling(n,k,2) k=0 to n

\\ A131689 k! * stirling(n,k,2) k=0 to n
\\ A019538 k! * stirling(n,k,2) k=1 to n
\\ labelled forests of n+k vertices with k component trees, roots 1..k and
\\ each root at least one child