# Copyright 2021 Kevin Ryde

# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  See the file COPYING.  If not, see
# <http://www.gnu.org/licenses/>.


use 5.005;
use strict;
use FindBin;
use File::Spec;

# uncomment this to run the ### lines
use Smart::Comments;

my %degrees_to_count;
open my $fh, '<', "$ENV{HOME}/Downloads/new/hitree10.txt" or die;
while (defined(my $line = readline $fh)) {
  # $line
  my @degrees;
  while ($line =~ /\d+/g) { $degrees[$&]++; }
  @degrees = sort {$a<=>$b} @degrees;
  my $key = join(',',map {sprintf('%02d',$_)} @degrees);
  ### $key
  $degrees_to_count{$key}++;
}

### %degrees_to_count
foreach my $key (sort keys %degrees_to_count) {
  print "$degrees_to_count{$key},";
}
print "\n";
exit 0;
